<template>
  <div class="flex flex-col">
    <a-input label="Name:" placeholder="name" :validators="nameValidators"
      v-model="mason.name" />
    <a-input label="Profession:" placeholder="profession" :validators="professionValidators"
      v-model="mason.profession" />
    <selector title="Degree:" :options="ranks" v-model="mason.rank"
      :defaultOption="mason.rank" />
    <Selector title="Lodge id:" :options="lodges_ids" v-model="mason.lodge_id"
      :defaultOption="mason.lodge_id" />
    <a-input label="Acceptance date:" placeholder="date" :validators="dateValidators"
      v-model="mason.acceptance_date" />
    <div class="flex justify-center">
      <SubmitButton value="post" @click="submit" />
      <CancelButton value="cancel" @click="cancel" />
    </div>
  </div>
</template>

<script>
import { useRoute } from 'vue-router';
import { mapGetters } from 'vuex';
import AInput from '@/components/AInput.vue';
import Selector from '@/components/Selector.vue';
import SubmitButton from '@/components/SubmitButton.vue';
import CancelButton from '@/components/CancelButton.vue'
import { dateValidator, nameValidator, emptyValidator } from '@/components/Validators.js'
import axiosClient from '@/axiosClient';
import { convertStrToTimestamp } from '@/components/helpers.js'

export default {
  components: {
    AInput,
    Selector,
    SubmitButton,
    CancelButton
  },
  data() {
    return {
      mason: {},
      nameValidators: [nameValidator],
      dateValidators: [dateValidator],
      professionValidators: [emptyValidator],
      dateValidators: [dateValidator],
      ranks: ["Entered Apprentice", "Fellow Craft", "Master Mason"],
      lodges_ids: [],
      new: false,
    }
  },
  methods: {
    submit() {
      if (this.new) {
        this.create()
      } else {
        this.update()
      }
    },
    create() {
      const payload = JSON.stringify({
        data: {
          attributes: {
            lodge_id: Number(this.mason.lodge_id),
            name: this.mason.name,
            rank: this.mason.rank,
            profession: this.mason.profession,
            acceptance_date: convertStrToTimestamp(this.mason.acceptance_date)
          }
        }
      })
      
      axiosClient.post('/masons', payload)
        .then(() => {
          this.$router.go(-1)
        })
    },
    update() {
      const payload = JSON.stringify({
        data: {
          attributes: {
            new_lodge_id: Number(this.mason.lodge_id),
            new_name: this.mason.name,
            new_rank: this.mason.rank,
            new_profession: this.mason.profession,
            new_acceptance_date: convertStrToTimestamp(this.mason.acceptance_date)
          }
        }
      })
      
      axiosClient.patch(`/masons/${this.mason.id}`, payload)
        .then(() => {
          this.$router.go(-1)
        })
    },
    cancel() {
      this.$router.go(-1)
    }
  },
  computed: {
    ...mapGetters({
      masonById: "getMason",
      lodges: "getLodges",
    })
  },
  created() {
    if (useRoute().params.id != 'new') {
      Object.assign(this.mason = this.masonById(useRoute().params.id))
    } else {
      this.new = true
      this.mason.lodge_id = 1
      this.mason.rank = "Entered Apprentice"
    }
    axiosClient.get('/lodges')
      .then((response) => {
        for (let lodge_data of response.data.data) {
          this.lodges_ids.push(lodge_data.id)
        }
      })
  }
}

</script>